#include "nRF24L01.h"
#include "SPI_Driver.h"

void nRF24L01_SPI_Init(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure;
  SPI_GPIO_Config();	  //SPIӦ
  // CE --> PB5
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_5 ;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT; 
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOB, &GPIO_InitStructure);
}

/*Ĵ*/
uint8_t nRF24L01_ReadRegister(uint8_t regAddr )
{
	uint8_t reg_val;	
	NRF24L01_SPI_CS_L;       //CS=0 ,ѡͨоƬ  SPIƬѡź 
	SPI_RW(regAddr);         //дַ   
	reg_val = SPI_RW(0);     //0
	NRF24L01_SPI_CS_H;     
	return(reg_val);      
}


/*дĴ*/
uint8_t nRF24L01_WriteRegister(uint8_t regAddr, uint8_t value )
{  
	uint8_t status; 
	NRF24L01_SPI_CS_L;       
	SPI_RW(regAddr);      //дַ  
	SPI_RW(value);        //дĴ
	NRF24L01_SPI_CS_H; 
	return (status);  // ״ֵ̬
}

/*ܣڶ
regAddr: ΪĴַ  pBuffer: Ϊݵַ  count: ݸ
*/
uint8_t nRF24L01_ReadRegisterN( uint8_t regAddr, uint8_t *pBuffer, uint8_t count )
{
	uint8_t status;
	NRF24L01_SPI_CS_L;        // CS = 0
	status=SPI_RW(regAddr);      
	while(count--) {
		*pBuffer++ = SPI_RW(0);
	}   
	NRF24L01_SPI_CS_H; 
	return status;
}

/*ܣд
regAddr: ΪĴַ  pBuffer: Ϊдݵַ  count: дݸ
*/
uint8_t nRF24L01_WriteRegisterN( uint8_t regAddr, uint8_t *pBuffer, uint8_t count )
{
	uint8_t status;
	NRF24L01_SPI_CS_L;       
	status = SPI_RW(regAddr);      
	while(count--) {
		SPI_RW(*pBuffer++);
	}   
	NRF24L01_SPI_CS_H; 
	return status;
}

#define TX_ADR_WIDTH    5   	// 5 uints TX address width
#define RX_ADR_WIDTH    5   	// 5 uints RX address width
#define TX_PLOAD_WIDTH  32	// 20 uints(ֽ) TX payload(Чֵ)
#define RX_PLOAD_WIDTH  32	// 20 uints TX payload				 
uint8_t  TX_ADDRESS[TX_ADR_WIDTH]= {0x34,0x43,0x10,0x10,0x01};	//صַ
uint8_t  RX_ADDRESS[RX_ADR_WIDTH]= {0x34,0x43,0x10,0x10,0x01};	//յַ


//NRF24L01һ
//txbuf:׵ַ
//ֵ:״
uint8_t NRF24L01_TxPacket(uint8_t *txbuf)
{
	uint8_t sta; 
	NRF24L01_CE_L;
  nRF24L01_WriteRegisterN(WR_TX_PLOAD,txbuf,TX_PLOAD_WIDTH);//дݵTX BUF  32ֽ
 	NRF24L01_CE_H;//	   
	while(SPI_I2S_GetFlagStatus(SPI1,SPI_I2S_FLAG_TXE) == RESET);//ȴ
		sta= nRF24L01_ReadRegister(STATUS);  //ȡ״̬Ĵֵ	   
	nRF24L01_WriteRegister(wRITE_REG+STATUS,sta); //TX_DSMAX_RTжϱ־
	if(sta&STATUS_MAX_TX )//ﵽط
	{
		nRF24L01_WriteRegister(FLUSH_TX,0xff);//TX FIFOĴ 
		return STATUS_MAX_TX; 
	}
	if(sta&STATUS_TX_DS)//
	{
		return STATUS_TX_DS;
	}
	return 0xff;//ԭʧ
}
//NRF24L01һ
//txbuf:׵ַ
//ֵ:0ɣ
uint8_t NRF24L01_RxPacket(uint8_t *rxbuf)
{
	uint8_t sta;		    							   
	sta= nRF24L01_ReadRegister(STATUS);  //ȡ״̬Ĵֵ    	 
	nRF24L01_WriteRegister(wRITE_REG+STATUS,sta); //TX_DSMAX_RTжϱ־
	if(sta&STATUS_RX_DR)//յ
	{
		nRF24L01_ReadRegisterN(RD_RX_PLOAD,rxbuf,RX_PLOAD_WIDTH);//ȡ
		nRF24L01_WriteRegister(FLUSH_RX,0xff);//RX FIFOĴ 
		return 0; 
	}	   
	return 1;//ûյκ
}					    
//úʼNRF24L01RXģʽ
//RXַ,дRXݿ,ѡRFƵ,ʺLNA HCURR
//CEߺ,RXģʽ,Խ		   
void NRF24L01_RX_Mode(void)
{
		NRF24L01_CE_L;	  
  	nRF24L01_WriteRegisterN(wRITE_REG+RX_ADDR_P0,(uint8_t*)RX_ADDRESS,RX_ADR_WIDTH);//дRXڵַ
	  
  	nRF24L01_WriteRegister(wRITE_REG+EN_AA,0x01);    //ʹͨ0ԶӦ    
  	nRF24L01_WriteRegister(wRITE_REG+EN_RXADDR,0x01);//ʹͨ0Ľյַ  	 
  	nRF24L01_WriteRegister(wRITE_REG+RF_CH,40);	     //RFͨƵ		  
  	nRF24L01_WriteRegister(wRITE_REG+RX_PW_P0,RX_PLOAD_WIDTH);//ѡͨ0Чݿ 	    
  	nRF24L01_WriteRegister(wRITE_REG+RF_SETUP,0x0f);//TX,0db,2Mbps,濪   
  	nRF24L01_WriteRegister(wRITE_REG+CONFIG, 0x0f) ;//ûģʽĲ;PWR_UP,EN_CRC,16BIT_CRC,ģʽ 
  	nRF24L01_WriteRegister(FLUSH_RX,0xff);  //RX FIFOĴ
	  NRF24L01_CE_H; //CEΪ,ģʽ 
}						 
//úʼNRF24L01TXģʽ
//TXַ,дTXݿ,RXԶӦĵַ,TX,ѡRFƵ,ʺLNA HCURR
//PWR_UP,CRCʹ
//CEߺ,RXģʽ,Խ		   
//CEΪߴ10us,.	 
void NRF24L01_TX_Mode(void)
{														 
	  NRF24L01_CE_L;	    
  	nRF24L01_WriteRegisterN(wRITE_REG+TX_ADDR,(uint8_t*)TX_ADDRESS,TX_ADR_WIDTH);//дTXڵַ 
  	nRF24L01_WriteRegisterN(wRITE_REG+RX_ADDR_P0,(uint8_t*)RX_ADDRESS,RX_ADR_WIDTH); //TXڵַ,ҪΪʹACK	  

  	nRF24L01_WriteRegister(wRITE_REG+EN_AA,0x01);     //ʹͨ0ԶӦ    
  	nRF24L01_WriteRegister(wRITE_REG+EN_RXADDR,0x01); //ʹͨ0Ľյַ  
  	nRF24L01_WriteRegister(wRITE_REG+SETUP_RETR,0x1a);//Զطʱ:500us + 86us;Զط:10
  	nRF24L01_WriteRegister(wRITE_REG+RF_CH,40);       //RFͨΪ40
  	nRF24L01_WriteRegister(wRITE_REG+RF_SETUP,0x0f);  //TX,0db,2Mbps,濪   
  	nRF24L01_WriteRegister(wRITE_REG+CONFIG,0x0e);    //ûģʽĲ;PWR_UP,EN_CRC,16BIT_CRC,ģʽ,ж
	  NRF24L01_CE_H;//CEΪ,10us
}		  
