#ifndef _NRF24L01_H_
#define _NRF24L01_H_

#include "stm32f0xx.h"
#include <stdbool.h>

//***************************************NRF24L01Ĵָ*******************************************************
#define rEAD_REG        0x00  	// Ĵָ
#define wRITE_REG       0x20 	// дĴָ
#define RD_RX_PLOAD     0x61  	// ȡָ
#define WR_TX_PLOAD     0xA0  	// дָ
#define FLUSH_TX        0xE1 	// ϴ FIFOָ
#define FLUSH_RX        0xE2  	// ϴ FIFOָ
#define REUSE_TX_PL     0xE3  	// ظװָ
#define NOP             0xFF  	// ղ״̬Ĵ
//*************************************SPI(nRF24L01)Ĵַ****************************************************
#define CONFIG          0x00  // շ״̬CRCУģʽԼշ״̬Ӧʽ
#define EN_AA           0x01  // ԶӦ
#define EN_RXADDR       0x02  // ŵ
#define SETUP_AW        0x03  // շַ
#define SETUP_RETR      0x04  // Զط
#define RF_CH           0x05  // Ƶ
#define RF_SETUP        0x06  // ʡĹ
#define STATUS          0x07  // ״̬Ĵ
#define OBSERVE_TX      0x08  // ͼ⹦
#define CD              0x09  // ַ           
#define RX_ADDR_P0      0x0A  // Ƶ0ݵַ
#define RX_ADDR_P1      0x0B  // Ƶ1ݵַ
#define RX_ADDR_P2      0x0C  // Ƶ2ݵַ
#define RX_ADDR_P3      0x0D  // Ƶ3ݵַ
#define RX_ADDR_P4      0x0E  // Ƶ4ݵַ
#define RX_ADDR_P5      0x0F  // Ƶ5ݵַ
#define TX_ADDR         0x10  // ͵ַĴ
#define RX_PW_P0        0x11  // Ƶ0ݳ
#define RX_PW_P1        0x12  // Ƶ0ݳ
#define RX_PW_P2        0x13  // Ƶ0ݳ
#define RX_PW_P3        0x14  // Ƶ0ݳ
#define RX_PW_P4        0x15  // Ƶ0ݳ
#define RX_PW_P5        0x16  // Ƶ0ݳ
#define FIFO_STATUS     0x17  // FIFOջջ״̬Ĵ
 

// Status mask
#define STATUS_RX_DR    0x40
#define STATUS_TX_DS    0x20
#define STATUS_MAX_TX   0x10//ﵽʹж
#define STATUS_RX_P_NO  0x0E
#define STATUS_TX_FULL  0x01

// config mask
#define CONFIG_PWR_UP   0x02  
#define CONFIG_PRIM_RX  0x01


// PA4   SPI_CS
// PA1   CE
// PA7   INT

#define NRF24L01_SPI_CS_H 	   GPIOB->BSRR  = GPIO_Pin_3;
#define NRF24L01_SPI_CS_L	     GPIOB->BRR  = GPIO_Pin_3;;

#define NRF24L01_CE_H          (GPIOB->BSRR = GPIO_Pin_5)   // PB5 = 1
#define NRF24L01_CE_L          (GPIOB->BRR  = GPIO_Pin_5)   // PB5 = 0
  
void nRF24L01_SPI_Init(void);


uint8_t   nRF24L01_ReadRegister(uint8_t regAddr );
uint8_t nRF24L01_WriteRegister(uint8_t regAddr, uint8_t value );
uint8_t nRF24L01_ReadRegisterN( uint8_t regAddr, uint8_t *pBuffer, uint8_t count );
uint8_t nRF24L01_WriteRegisterN( uint8_t regAddr, uint8_t *pBuffer, uint8_t count );

uint8_t NRF24L01_TxPacket(uint8_t *txbuf);
uint8_t NRF24L01_RxPacket(uint8_t *rxbuf);
void NRF24L01_RX_Mode(void);
void NRF24L01_TX_Mode(void);

#endif  /* _NRF24L01_H_ */
